scala.tools.nsc.backend.icode.TypeKinds

# TypeKind

#### sealed abstract class TypeKind extends AnyRef

This class represents a type kind. Type kinds represent the types that the VM know (or the ICode view of what VMs know).

Source
  TypeKinds.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
ARRAY, BOOL, BOXED, BYTE, CHAR, ConcatClass, DOUBLE, FLOAT, INT, LONG, REFERENCE, SHORT, UNIT, ValueTypeKind
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TypeKind
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new TypeKind()

### Abstract Value Members

1. #### abstract def <:<(other: ICodes.TypeKind): Boolean

   Simple subtyping check

2. #### abstract def maxType(other: ICodes.TypeKind): ICodes.TypeKind

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodes.TypeKind to any2stringadd[ICodes.TypeKind] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodes.TypeKind, B)

   Implicit information
     This member is added by an implicit conversion from ICodes.TypeKind to ArrowAssoc[ICodes.TypeKind] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

8. #### def dimensions: Int

   The number of dimensions for array types.

9. #### def ensuring(cond: (ICodes.TypeKind) ⇒ Boolean, msg: ⇒ Any): ICodes.TypeKind

   Implicit information
     This member is added by an implicit conversion from ICodes.TypeKind to Ensuring[ICodes.TypeKind] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: (ICodes.TypeKind) ⇒ Boolean): ICodes.TypeKind

    Implicit information
      This member is added by an implicit conversion from ICodes.TypeKind to Ensuring[ICodes.TypeKind] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodes.TypeKind

    Implicit information
      This member is added by an implicit conversion from ICodes.TypeKind to Ensuring[ICodes.TypeKind] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean): ICodes.TypeKind

    Implicit information
      This member is added by an implicit conversion from ICodes.TypeKind to Ensuring[ICodes.TypeKind] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

16. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodes.TypeKind to StringFormat[ICodes.TypeKind] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

17. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

18. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

19. #### def isArrayType: Boolean

20. #### final def isAssignabledTo(other: ICodes.TypeKind): Boolean

    this is directly assignable to other if no coercion or casting is needed to convert this to other.

    this is directly assignable to other if no coercion or casting is needed to convert this to other. It's a distinct relationship from <:< because on the JVM, BOOL, BYTE, CHAR, SHORT need no coercion to INT even though JVM arrays are covariant, ARRAY[SHORT] is not a subtype of ARRAY[INT]

21. #### def isBoxedType: Boolean

22. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

23. #### def isIntSizedType: Boolean

    On the JVM, BOOL, BYTE, CHAR, SHORT, and INT are like Ints for the purposes of calculating the lub.

24. #### def isIntegralType: Boolean

    On the JVM, similar to isIntSizedType except that BOOL isn't integral while LONG is.

25. #### final def isInterfaceType: Boolean

26. #### final def isNothingType: Boolean

27. #### final def isNullType: Boolean

28. #### final def isNumericType: Boolean

29. #### def isRealType: Boolean

    On the JVM, FLOAT and DOUBLE.

30. #### final def isRefOrArrayType: Boolean

31. #### def isReferenceType: Boolean

32. #### def isValueType: Boolean

33. #### def isWideType: Boolean

    Is this type a category 2 type in JVM terms? (ie, is it LONG or DOUBLE?)

34. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

35. #### final def notify(): Unit

    Definition Classes
      AnyRef

36. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

37. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

38. #### def toString(): String

    Definition Classes
      AnyRef → Any

39. #### def toType: Global.Type

40. #### def uncomparable(other: ICodes.TypeKind): Nothing

    Attributes
      protected

41. #### def uncomparable(thisKind: String, other: ICodes.TypeKind): Nothing

    Attributes
      protected

42. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### def →[B](y: B): (ICodes.TypeKind, B)

    Implicit information
      This member is added by an implicit conversion from ICodes.TypeKind to ArrowAssoc[ICodes.TypeKind] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodes.TypeKind to any2stringadd[ICodes.TypeKind]

### Inherited by implicit conversion StringFormat from ICodes.TypeKind to StringFormat[ICodes.TypeKind]

### Inherited by implicit conversion Ensuring from ICodes.TypeKind to Ensuring[ICodes.TypeKind]

### Inherited by implicit conversion ArrowAssoc from ICodes.TypeKind to ArrowAssoc[ICodes.TypeKind]

### Ungrouped